# Define templates
include:
  - project: ${GITLAB_CI_TEMPLATES_PATH}
    file: ${GITLAB_CI_TEMPLATES_FILE}
    ref: '1.0.3'

# Define stages
stages:
  - build
  - predeploy
  - deploy
  - test
  - publish
  - release
  - upgrade
  - clean

# Define global variables
variables:
  P_NAME: "gazelle-transformation-ws-client"
  P_APP_TYPE: "java"
  P_CODE_SRC_PATH: "."
  P_MAVEN_IMAGE_TAG: "3.6.3-jdk-8-slim"

# Define jobs
compile/unit-test:
  stage: build
  extends:
    - .buildJavaMavenTest

package:
  stage: build
  extends:
    - .buildJavaMavenPackage
  needs:
    - job: compile/unit-test
      artifacts: true
  variables:
    P_MAVEN_EXTRA_ARGS: "-DskipTests"

static-analysis:
  stage: test
  extends:
    - .testJavaMavenSonarAnalysis
  needs:
    - job: compile/unit-test
      artifacts: true
  variables:
    P_MAVEN_EXTRA_ARGS: "-Psonar -DskipTests"

install-cache-repo:
  stage: publish
  extends:
    - .publishJavaMavenInstall
  needs:
    - job: package
      artifacts: true
  variables:
    P_MAVEN_EXTRA_ARGS: "-DskipTests"

publish-code:
  stage: publish
  extends:
    - .publishJavaMavenDeploy
  needs:
    - job: package
      artifacts: true

release/code:
  stage: release
  extends:
    - .releaseCodeForJava
